# -*- coding: utf-8 -*-
# xDevs.com Python 10V test for 3458A
# http://xdevs.com/guide/ni_gpib_rpi/
import os.path
import sys
#import Gpib
import vxi11
import time
import ftplib
import numbers
import signal
from Adafruit_BME280 import *

root_dir = '/repo/teckit_git/'
fileName4 = root_dir + 'digitize_3458_1v_100mhz_aper20000us_tin.csv'

cnt = 0
tread = 20
reflevel = 0.1
refhp = 0.1

exttemp = 25.0
rh = 50.0
pascals = 100000.00
hectopascals = 1000.00

class Timeout():
  """Timeout class using ALARM signal"""
  class Timeout(Exception): pass

  def __init__(self, sec):
    self.sec = sec

  def __enter__(self):
    signal.signal(signal.SIGALRM, self.raise_timeout)
    signal.alarm(self.sec)

  def __exit__(self, *args):
    signal.alarm(0) # disable alarm

  def raise_timeout(self, *args):
    raise Timeout.Timeout()

class meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals

    def __init__(self,gpib,refhp,name):
        self.gpib = gpib
        #self.inst = Gpib.Gpib(0,self.gpib, timeout=60) # 3458A GPIB Address = self.gpib
	self.inst = vxi11.Instrument("192.168.1.118", "gpib0,%d" % self.gpib)
	self.inst.timeout = 60
        self.refhp = refhp
        self.name = name
        self.init_inst_dig_dcv()

    def init_inst(self):
        # Setup HP 3458A
        self.inst.clear()
        self.inst.write("PRESET NORM")
        self.inst.write("OFORMAT ASCII")
        self.inst.write("DCV 0.1")
        self.inst.write("TARM HOLD")
        self.inst.write("TRIG AUTO")
        self.inst.write("NPLC 100")
        self.inst.write("AZERO ON")
	#self.inst.write("OCOMP ON")
        self.inst.write("LFILTER ON")
        self.inst.write("NRDGS 1,AUTO")
        self.inst.write("MEM OFF")
        self.inst.write("END ALWAYS")
        self.inst.write("NDIG 9")

    def init_inst_dig_dcv(self):
        # Setup HP 3458A
        self.inst.clear()
        self.inst.write("PRESET DIG")
        self.inst.write("MFORMAT DINT")
        self.inst.write("OFORMAT ASCII")
	self.inst.write("MEM FIFO")
        self.inst.write("APER 20000e-6")
        self.inst.write("DCV 1")
        self.inst.write("TRIG AUTO")
#	self.inst.write("LEVEL 0,AC")
	#self.inst.write("TIMER 500e-6")
        self.inst.write("NRDGS 1024,AUTO")
        self.inst.write("AZERO OFF")
	#self.inst.write("DELAY 0")
	self.inst.write("END ON")
        self.inst.write("TARM HOLD")
        self.inst.write("DISP OFF")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""

        self.inst.write(cmd)

        try:
            with Timeout(20):
		#print "%c" % self.inst.read()
		quit()
                #data_str = unicode(self.inst.read(), errors='ignore')
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        #try:
        #    data_float = float(data_str)
        #except ValueError:
        #    print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
        #    return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_str) # Good read, 1 = converted to float w/o exception

    def get_temp(self):
        self.inst.write("TARM SGL,1")
        self.temp_status_flag,temp = self.read_data("TEMP?")
        if (self.temp_status_flag):
            self.temp = temp
        return self.temp

    def get_temp_status(self):
        return self.temp_status_flag

    def get_data(self):
        self.status_flag,data = self.read_data("TARM SGL")
        if (self.status_flag):
            self.data = data
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%s\r\n" % (self.data) ))
        return self.data

    def trigger(self):
	self.inst.write("TARM SGL")

    def get_value(self):
        self.data = self.inst.read()
        #    self.data = data
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%s\r\n" % (self.data) ))
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self,fileHandle):
        print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.9f , dev %4.4f ppm, T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(self.temp),float(exttemp),float(rh),float(hectopascals) ) )
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
        #self.inst.write("DISP OFF, \"%3.3f ppm\"" % float(self.ppm))
	#self.inst.write("DISP OFF, \" \"")
	time.sleep(0.1)
	#self.inst.write("DISP OFF, \"%9.8f VREF \"" % float(self.data))

# Read Temperature, Humidity, and Barometric Pressure from BME280
def get_THP():
    global exttemp
    global rh
    global pascals
    global hectopascals
    exttemp = sensor.read_temperature()
    rh = sensor.read_humidity()
    pascals = sensor.read_pressure()
    hectopascals = pascals / 100

# Check if file exists, if not create it and add header
def create_local_file(fileName):
    if (os.path.isfile(fileName) == False):
        with open(fileName, 'w') as o:
	    o.write("date;sample;hp3458a;iscale;ext_temp;rh;pressure;\r\n")
            print ("file %s does not exist\r\n" % fileName) 
    else: 
        print ("file %s exists\r\n" % fileName)

meter1 = meter(3,refhp,"3458A_00000") # Gpib 3
print "Meter configured"

meter1.trigger()
print "Triggered 1024 samples"
rawval = []

for xv in range (0, 1023):
    rawval.append(meter1.get_value())
    print "%d %.6f" % (xv, float(rawval[xv]) )
print rawval
#Setup temp/humidity/pressure sensor BME280
# OSAMPLE = oversampling mode
sensor = BME280(mode=BME280_OSAMPLE_8)
get_THP() # Read Temp, RH, Pressure from sensor

create_local_file(fileName4)

with open(fileName4, 'a') as o1: # Open file handles for both files
    for xv in range (0, 1023):
	o1.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%d;%.8f;%.8f;%3.2f;%3.2f;%4.1f;\r\n" % (xv, float(rawval[xv]), 0.0, exttemp, rh, hectopascals)) )
    o1.close()

print "Done"
quit()

# Create file for 1st 3458A and write header if needed

while cnt <= 100000:
    cnt+=1
    with open(fileName4, 'a') as o1: # Open file handles for both files
        tread = tread - 1
        if (tread == 0):
            tread = 150
            meter1.get_temp()

        get_THP() # Read Temp, RH, Press from sensor
        meter1.get_data()
        if (meter1.get_data_status()):
            meter1.print_ppm()
            meter1.write_data(o1)

        o1.close()
